variables:
  DOCKER_DRIVER: overlay
  BRANCH: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  COMMIT: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

stages:
    - dist
    - test
    - lint
    - docker

dist:
    stage: dist
    image: python:3.7
    script: 
        - python -m pip install setuptools
        - python setup.py sdist bdist_wheel
    artifacts:
        paths:
            - dist
    allow_failure: true

test:
    stage: test
    image: debian:buster
    before_script:
        - apt-get update
        - apt-get upgrade
        - apt-get install --install-recommends --assume-yes python3-pip libpq-dev
        - pip3 install --upgrade pip setuptools
    script:
        - pip3 install dist/igwn-alert-supervisor-*.tar.gz
        - igwn_alert_supervisor --help
    allow_failure: true
    needs:
        - dist

lint:
    stage: lint
    image: python:3.7
    script:
        - pip install flake8
        - flake8
    allow_failure: true

docker:
    stage: docker
    image: docker:latest
    script:
        - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
        - docker build --pull -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME --file Dockerfile .
        - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
    needs:
        - test
        - lint
